
_set_up:

;Lm317_controlled_by_PWM.c,23 :: 		void set_up() {
;Lm317_controlled_by_PWM.c,25 :: 		ANSEL = 0x04;      // Pin RA2 sets as analog input.
	MOVLW      4
	MOVWF      ANSEL+0
;Lm317_controlled_by_PWM.c,26 :: 		TRISA = 0x04;
	MOVLW      4
	MOVWF      TRISA+0
;Lm317_controlled_by_PWM.c,27 :: 		ADCON1 = 0x82;    // the Vref is Vcc.
	MOVLW      130
	MOVWF      ADCON1+0
;Lm317_controlled_by_PWM.c,28 :: 		ANSELH = 0;      // the rest of the pins set as digital Inputs or outputs.
	CLRF       ANSELH+0
;Lm317_controlled_by_PWM.c,29 :: 		C1ON_bit = 0;    // analog comparators off.
	BCF        C1ON_bit+0, BitPos(C1ON_bit+0)
;Lm317_controlled_by_PWM.c,30 :: 		C2ON_bit = 0;
	BCF        C2ON_bit+0, BitPos(C2ON_bit+0)
;Lm317_controlled_by_PWM.c,31 :: 		TRISB0_bit=1;
	BSF        TRISB0_bit+0, BitPos(TRISB0_bit+0)
;Lm317_controlled_by_PWM.c,32 :: 		TRISB1_bit=1;
	BSF        TRISB1_bit+0, BitPos(TRISB1_bit+0)
;Lm317_controlled_by_PWM.c,33 :: 		TRISC2_bit=0;
	BCF        TRISC2_bit+0, BitPos(TRISC2_bit+0)
;Lm317_controlled_by_PWM.c,34 :: 		TRISE0_bit=1;
	BSF        TRISE0_bit+0, BitPos(TRISE0_bit+0)
;Lm317_controlled_by_PWM.c,35 :: 		TRISE1_bit=1;
	BSF        TRISE1_bit+0, BitPos(TRISE1_bit+0)
;Lm317_controlled_by_PWM.c,36 :: 		ADC_Init();
	CALL       _ADC_Init+0
;Lm317_controlled_by_PWM.c,37 :: 		delay_us(100);
	MOVLW      33
	MOVWF      R13+0
L_set_up0:
	DECFSZ     R13+0, 1
	GOTO       L_set_up0
;Lm317_controlled_by_PWM.c,38 :: 		PWM1_Init(2000); //2KHz
	BSF        T2CON+0, 0
	BCF        T2CON+0, 1
	MOVLW      124
	MOVWF      PR2+0
	CALL       _PWM1_Init+0
;Lm317_controlled_by_PWM.c,39 :: 		PWM1_Start();
	CALL       _PWM1_Start+0
;Lm317_controlled_by_PWM.c,40 :: 		Lcd_Init(); // LCD display initialization
	CALL       _Lcd_Init+0
;Lm317_controlled_by_PWM.c,41 :: 		Lcd_Cmd(_LCD_CURSOR_OFF); // LCD command (cursor off)
	MOVLW      12
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;Lm317_controlled_by_PWM.c,42 :: 		Lcd_Cmd(_LCD_CLEAR); // LCD command (clear LCD)
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;Lm317_controlled_by_PWM.c,43 :: 		text = "Voltage:";
	MOVLW      ?lstr1_Lm317_controlled_by_PWM+0
	MOVWF      _text+0
;Lm317_controlled_by_PWM.c,44 :: 		Lcd_Out(1,1,text);
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _text+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;Lm317_controlled_by_PWM.c,45 :: 		text = "Scale:";
	MOVLW      ?lstr2_Lm317_controlled_by_PWM+0
	MOVWF      _text+0
;Lm317_controlled_by_PWM.c,46 :: 		Lcd_Out(2,4,text);
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      4
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _text+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;Lm317_controlled_by_PWM.c,47 :: 		}
L_end_set_up:
	RETURN
; end of _set_up

_reading:

;Lm317_controlled_by_PWM.c,48 :: 		void reading() {
;Lm317_controlled_by_PWM.c,51 :: 		voltage = adc_rd/10.240;
	MOVF       _adc_rd+0, 0
	MOVWF      R0+0
	MOVF       _adc_rd+1, 0
	MOVWF      R0+1
	CALL       _word2double+0
	MOVLW      10
	MOVWF      R4+0
	MOVLW      215
	MOVWF      R4+1
	MOVLW      35
	MOVWF      R4+2
	MOVLW      130
	MOVWF      R4+3
	CALL       _Div_32x32_FP+0
	MOVF       R0+0, 0
	MOVWF      _voltage+0
	MOVF       R0+1, 0
	MOVWF      _voltage+1
	MOVF       R0+2, 0
	MOVWF      _voltage+2
	MOVF       R0+3, 0
	MOVWF      _voltage+3
;Lm317_controlled_by_PWM.c,52 :: 		voltage = voltage*0.25;
	MOVLW      0
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	MOVLW      0
	MOVWF      R4+2
	MOVLW      125
	MOVWF      R4+3
	CALL       _Mul_32x32_FP+0
	MOVF       R0+0, 0
	MOVWF      _voltage+0
	MOVF       R0+1, 0
	MOVWF      _voltage+1
	MOVF       R0+2, 0
	MOVWF      _voltage+2
	MOVF       R0+3, 0
	MOVWF      _voltage+3
;Lm317_controlled_by_PWM.c,53 :: 		FloatToStr(voltage, txt);
	MOVF       R0+0, 0
	MOVWF      FARG_FloatToStr_fnum+0
	MOVF       R0+1, 0
	MOVWF      FARG_FloatToStr_fnum+1
	MOVF       R0+2, 0
	MOVWF      FARG_FloatToStr_fnum+2
	MOVF       R0+3, 0
	MOVWF      FARG_FloatToStr_fnum+3
	MOVLW      _txt+0
	MOVWF      FARG_FloatToStr_str+0
	CALL       _FloatToStr+0
;Lm317_controlled_by_PWM.c,54 :: 		Lcd_Out(1,9,txt);
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      9
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _txt+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;Lm317_controlled_by_PWM.c,56 :: 		Lcd_Chr(2,10,48+ch);
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVLW      10
	MOVWF      FARG_Lcd_Chr_column+0
	MOVF       _scale+0, 0
	ADDLW      48
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
;Lm317_controlled_by_PWM.c,58 :: 		}
L_end_reading:
	RETURN
; end of _reading

_main:

;Lm317_controlled_by_PWM.c,60 :: 		void main() {
;Lm317_controlled_by_PWM.c,61 :: 		set_up();
	CALL       _set_up+0
;Lm317_controlled_by_PWM.c,62 :: 		do  {
L_main1:
;Lm317_controlled_by_PWM.c,63 :: 		adc_rd= ADC_Get_Sample(2);
	MOVLW      2
	MOVWF      FARG_ADC_Get_Sample_channel+0
	CALL       _ADC_Get_Sample+0
	MOVF       R0+0, 0
	MOVWF      _adc_rd+0
	MOVF       R0+1, 0
	MOVWF      _adc_rd+1
;Lm317_controlled_by_PWM.c,64 :: 		reading();
	CALL       _reading+0
;Lm317_controlled_by_PWM.c,66 :: 		if(scale==0) aux=0;  // duty stays with the same value
	MOVF       _scale+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main4
	CLRF       _aux+0
L_main4:
;Lm317_controlled_by_PWM.c,67 :: 		if(scale==1) aux=1;
	MOVF       _scale+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_main5
	MOVLW      1
	MOVWF      _aux+0
L_main5:
;Lm317_controlled_by_PWM.c,68 :: 		if(scale==2) aux=3;
	MOVF       _scale+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L_main6
	MOVLW      3
	MOVWF      _aux+0
L_main6:
;Lm317_controlled_by_PWM.c,69 :: 		if(scale==3) aux=5;
	MOVF       _scale+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L_main7
	MOVLW      5
	MOVWF      _aux+0
L_main7:
;Lm317_controlled_by_PWM.c,70 :: 		if(scale==4) aux=15;
	MOVF       _scale+0, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L_main8
	MOVLW      15
	MOVWF      _aux+0
L_main8:
;Lm317_controlled_by_PWM.c,71 :: 		if(scale==5) aux=17;
	MOVF       _scale+0, 0
	XORLW      5
	BTFSS      STATUS+0, 2
	GOTO       L_main9
	MOVLW      17
	MOVWF      _aux+0
L_main9:
;Lm317_controlled_by_PWM.c,72 :: 		if(scale==6) aux=51;
	MOVF       _scale+0, 0
	XORLW      6
	BTFSS      STATUS+0, 2
	GOTO       L_main10
	MOVLW      51
	MOVWF      _aux+0
L_main10:
;Lm317_controlled_by_PWM.c,73 :: 		if(scale==7) aux=85;
	MOVF       _scale+0, 0
	XORLW      7
	BTFSS      STATUS+0, 2
	GOTO       L_main11
	MOVLW      85
	MOVWF      _aux+0
L_main11:
;Lm317_controlled_by_PWM.c,74 :: 		if(scale==8) aux=127;
	MOVF       _scale+0, 0
	XORLW      8
	BTFSS      STATUS+0, 2
	GOTO       L_main12
	MOVLW      127
	MOVWF      _aux+0
L_main12:
;Lm317_controlled_by_PWM.c,76 :: 		if (Button(&PORTB,0,1,0)) E2=0;      //if the button has been pushed
	MOVLW      PORTB+0
	MOVWF      FARG_Button_port+0
	CLRF       FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main13
	CLRF       _E2+0
L_main13:
;Lm317_controlled_by_PWM.c,77 :: 		if (E2==0 && Button(&PORTB,0,1,1)){  //and after that the button is free
	MOVF       _E2+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main16
	MOVLW      PORTB+0
	MOVWF      FARG_Button_port+0
	CLRF       FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main16
L__main37:
;Lm317_controlled_by_PWM.c,78 :: 		scale++;                         //increase scale.
	INCF       _scale+0, 1
;Lm317_controlled_by_PWM.c,79 :: 		if (scale>8) scale=0;
	MOVLW      128
	XORLW      8
	MOVWF      R0+0
	MOVLW      128
	XORWF      _scale+0, 0
	SUBWF      R0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_main17
	CLRF       _scale+0
L_main17:
;Lm317_controlled_by_PWM.c,80 :: 		E2=1;
	MOVLW      1
	MOVWF      _E2+0
;Lm317_controlled_by_PWM.c,81 :: 		}
L_main16:
;Lm317_controlled_by_PWM.c,82 :: 		if (Button(&PORTB,1,1,0)) E3=0;      //if the button has been pushed
	MOVLW      PORTB+0
	MOVWF      FARG_Button_port+0
	MOVLW      1
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main18
	CLRF       _E3+0
L_main18:
;Lm317_controlled_by_PWM.c,83 :: 		if (E3==0 && Button(&PORTB,1,1,1)){  //and after that the button is free
	MOVF       _E3+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main21
	MOVLW      PORTB+0
	MOVWF      FARG_Button_port+0
	MOVLW      1
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main21
L__main36:
;Lm317_controlled_by_PWM.c,84 :: 		scale--;                         //decrase scale.
	DECF       _scale+0, 1
;Lm317_controlled_by_PWM.c,85 :: 		if (scale<0) scale=8;
	MOVLW      128
	XORWF      _scale+0, 0
	MOVWF      R0+0
	MOVLW      128
	XORLW      0
	SUBWF      R0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_main22
	MOVLW      8
	MOVWF      _scale+0
L_main22:
;Lm317_controlled_by_PWM.c,86 :: 		E3=1;
	MOVLW      1
	MOVWF      _E3+0
;Lm317_controlled_by_PWM.c,87 :: 		}
L_main21:
;Lm317_controlled_by_PWM.c,88 :: 		if (Button(&PORTE,0,1,0)) E0=0;      //if the button has been pushed
	MOVLW      PORTE+0
	MOVWF      FARG_Button_port+0
	CLRF       FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main23
	CLRF       _E0+0
L_main23:
;Lm317_controlled_by_PWM.c,89 :: 		if (E0==0 && Button(&PORTE,0,1,1)){  //and after that the button is free
	MOVF       _E0+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main26
	MOVLW      PORTE+0
	MOVWF      FARG_Button_port+0
	CLRF       FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main26
L__main35:
;Lm317_controlled_by_PWM.c,90 :: 		duty=duty+aux;                   //increase duty.
	MOVF       _aux+0, 0
	ADDWF      _duty+0, 0
	MOVWF      R1+0
	MOVF       _duty+1, 0
	BTFSC      STATUS+0, 0
	ADDLW      1
	MOVWF      R1+1
	MOVLW      0
	BTFSC      _aux+0, 7
	MOVLW      255
	ADDWF      R1+1, 1
	MOVF       R1+0, 0
	MOVWF      _duty+0
	MOVF       R1+1, 0
	MOVWF      _duty+1
;Lm317_controlled_by_PWM.c,91 :: 		if (duty>255) duty=255;
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      R1+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main41
	MOVF       R1+0, 0
	SUBLW      255
L__main41:
	BTFSC      STATUS+0, 0
	GOTO       L_main27
	MOVLW      255
	MOVWF      _duty+0
	CLRF       _duty+1
L_main27:
;Lm317_controlled_by_PWM.c,92 :: 		E0=1;
	MOVLW      1
	MOVWF      _E0+0
;Lm317_controlled_by_PWM.c,93 :: 		}
L_main26:
;Lm317_controlled_by_PWM.c,94 :: 		if (Button(&PORTE,1,1,0)) E1=0;      //if the button has been pushed
	MOVLW      PORTE+0
	MOVWF      FARG_Button_port+0
	MOVLW      1
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main28
	CLRF       _E1+0
L_main28:
;Lm317_controlled_by_PWM.c,95 :: 		if (E1==0 && Button(&PORTE,1,1,1)){  //and after that the button is free
	MOVF       _E1+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main31
	MOVLW      PORTE+0
	MOVWF      FARG_Button_port+0
	MOVLW      1
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main31
L__main34:
;Lm317_controlled_by_PWM.c,96 :: 		duty=duty-aux;               //decrease duty.
	MOVF       _aux+0, 0
	SUBWF      _duty+0, 0
	MOVWF      R1+0
	MOVLW      0
	BTFSC      _aux+0, 7
	MOVLW      255
	BTFSS      STATUS+0, 0
	ADDLW      1
	SUBWF      _duty+1, 0
	MOVWF      R1+1
	MOVF       R1+0, 0
	MOVWF      _duty+0
	MOVF       R1+1, 0
	MOVWF      _duty+1
;Lm317_controlled_by_PWM.c,97 :: 		if (duty<0) duty=0;
	MOVLW      128
	XORWF      R1+1, 0
	MOVWF      R0+0
	MOVLW      128
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main42
	MOVLW      0
	SUBWF      R1+0, 0
L__main42:
	BTFSC      STATUS+0, 0
	GOTO       L_main32
	CLRF       _duty+0
	CLRF       _duty+1
L_main32:
;Lm317_controlled_by_PWM.c,98 :: 		E1=1;
	MOVLW      1
	MOVWF      _E1+0
;Lm317_controlled_by_PWM.c,99 :: 		}
L_main31:
;Lm317_controlled_by_PWM.c,100 :: 		PWM1_Set_Duty(duty);
	MOVF       _duty+0, 0
	MOVWF      FARG_PWM1_Set_Duty_new_duty+0
	CALL       _PWM1_Set_Duty+0
;Lm317_controlled_by_PWM.c,101 :: 		delay_ms(100);
	MOVLW      130
	MOVWF      R12+0
	MOVLW      221
	MOVWF      R13+0
L_main33:
	DECFSZ     R13+0, 1
	GOTO       L_main33
	DECFSZ     R12+0, 1
	GOTO       L_main33
	NOP
	NOP
;Lm317_controlled_by_PWM.c,102 :: 		} while (1);
	GOTO       L_main1
;Lm317_controlled_by_PWM.c,103 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
